diff --git a/include/drm/amdgpu_drm.h b/include/drm/amdgpu_drm.h
index 1ceec56de0157671c6a4..e0f071d36f0849309815 100644
--- a/include/drm/amdgpu_drm.h
+++ b/include/drm/amdgpu_drm.h
@@ -204,9 +204,9 @@ union drm_amdgpu_bo_list {
 /* unknown cause */
 #define AMDGPU_CTX_UNKNOWN_RESET	3

-/* indicate gpu reset occured after ctx created */
+/* indicate gpu reset occurred after ctx created */
 #define AMDGPU_CTX_QUERY2_FLAGS_RESET    (1<<0)
-/* indicate vram lost occured after ctx created */
+/* indicate vram lost occurred after ctx created */
 #define AMDGPU_CTX_QUERY2_FLAGS_VRAMLOST (1<<1)
 /* indicate some job from this context once cause gpu hang */
 #define AMDGPU_CTX_QUERY2_FLAGS_GUILTY   (1<<2)
diff --git a/include/drm/drm_fourcc.h b/include/drm/drm_fourcc.h
index 139632b871816f9e3dad..15c6892980519ca9d8c9 100644
--- a/include/drm/drm_fourcc.h
+++ b/include/drm/drm_fourcc.h
@@ -294,7 +294,7 @@ extern "C" {
  * This is a tiled layout using 4Kb tiles in row-major layout.
  * Within the tile pixels are laid out in 16 256 byte units / sub-tiles which
  * are arranged in four groups (two wide, two high) with column-major layout.
- * Each group therefore consits out of four 256 byte units, which are also laid
+ * Each group therefore consists out of four 256 byte units, which are also laid
  * out as 2x2 column-major.
  * 256 byte units are made out of four 64 byte blocks of pixels, producing
  * either a square block or a 2:1 unit.
diff --git a/include/drm/drm_mode.h b/include/drm/drm_mode.h
index d3e0fe31efc55351573b..e61edf48ff76843e6b95 100644
--- a/include/drm/drm_mode.h
+++ b/include/drm/drm_mode.h
@@ -403,7 +403,7 @@ struct drm_mode_get_connector {
 /* the PROP_ATOMIC flag is used to hide properties from userspace that
  * is not aware of atomic properties.  This is mostly to work around
  * older userspace (DDX drivers) that read/write each prop they find,
- * witout being aware that this could be triggering a lengthy modeset.
+ * without being aware that this could be triggering a lengthy modeset.
  */
 #define DRM_MODE_PROP_ATOMIC        0x80000000

diff --git a/include/drm/i915_drm.h b/include/drm/i915_drm.h
index 268b585f8a4b5e8b39a2..3539f9b3ef02c1e7d1cb 100644
--- a/include/drm/i915_drm.h
+++ b/include/drm/i915_drm.h
@@ -485,7 +485,7 @@ typedef struct drm_i915_irq_wait {
 #define I915_PARAM_HAS_EXEC_FENCE	 44

 /* Query whether DRM_I915_GEM_EXECBUFFER2 supports the ability to capture
- * user specified bufffers for post-mortem debugging of GPU hangs. See
+ * user specified buffers for post-mortem debugging of GPU hangs. See
  * EXEC_OBJECT_CAPTURE.
  */
 #define I915_PARAM_HAS_EXEC_CAPTURE	 45
@@ -1180,7 +1180,7 @@ struct drm_i915_gem_caching {
 	__u32 handle;

 	/**
-	 * Cacheing level to apply or return value
+	 * Caching level to apply or return value
 	 *
 	 * bits0-15 are for generic caching control (i.e. the above defined
 	 * values). bits16-31 are reserved for platform-specific variations
diff --git a/include/drm/vmwgfx_drm.h b/include/drm/vmwgfx_drm.h
index 0bc784f5e0dbe15bc8d1..2b8d47ea3c7b61a2145e 100644
--- a/include/drm/vmwgfx_drm.h
+++ b/include/drm/vmwgfx_drm.h
@@ -361,7 +361,7 @@ struct drm_vmw_fence_rep {
  * Allocate a DMA buffer that is visible also to the host.
  * NOTE: The buffer is
  * identified by a handle and an offset, which are private to the guest, but
- * useable in the command stream. The guest kernel may translate these
+ * usable in the command stream. The guest kernel may translate these
  * and patch up the command stream accordingly. In the future, the offset may
  * be zero at all times, or it may disappear from the interface before it is
  * fixed.
@@ -446,7 +446,7 @@ struct drm_vmw_unref_dmabuf_arg {
  *
  * This IOCTL controls the overlay units of the svga device.
  * The SVGA overlay units does not work like regular hardware units in
- * that they do not automaticaly read back the contents of the given dma
+ * that they do not automatically read back the contents of the given dma
  * buffer. But instead only read back for each call to this ioctl, and
  * at any point between this call being made and a following call that
  * either changes the buffer or disables the stream.
@@ -1035,7 +1035,7 @@ union drm_vmw_gb_surface_reference_arg {
  * for read-only.
  * @drm_vmw_synccpu_write: Sync for write. Block all command submissions
  * referencing this buffer.
- * @drm_vmw_synccpu_dontblock: Dont wait for GPU idle, but rather return
+ * @drm_vmw_synccpu_dontblock: Don't wait for GPU idle, but rather return
  * -EBUSY should the buffer be busy.
  * @drm_vmw_synccpu_allow_cs: Allow command submission that touches the buffer
  * while the buffer is synced for CPU. This is similar to the GEM bo idle
---->8----
---
 amdgpu/amdgpu.h                |  6 +++---
 etnaviv/etnaviv_priv.h         |  2 +-
 exynos/exynos_drm.c            |  2 +-
 exynos/exynos_drm.h            |  2 +-
 exynos/exynos_drmif.h          |  2 +-
 freedreno/kgsl/README          |  2 +-
 freedreno/msm/msm_ringbuffer.c |  2 +-
 intel/intel_bufmgr_priv.h      |  2 +-
 intel/mm.h                     |  2 +-
 libkms/libkms.pc.in            |  2 +-
 man/drm.xml                    |  4 ++--
 meson.build                    |  2 +-
 tests/amdgpu/amdgpu_test.c     |  4 ++--
 tests/ttmtest/src/xf86dristr.h |  4 ++--
 xf86drm.c                      |  6 +++---
 xf86drmMode.h                  | 10 +++++-----
 16 files changed, 27 insertions(+), 27 deletions(-)

diff --git a/amdgpu/amdgpu.h b/amdgpu/amdgpu.h
index dc51659ae463a14ac0a3..ff4470de2170752b17f0 100644
--- a/amdgpu/amdgpu.h
+++ b/amdgpu/amdgpu.h
@@ -701,7 +701,7 @@ int amdgpu_find_bo_by_cpu_mapping(amdgpu_device_handle dev,
 				  uint64_t *offset_in_bo);
 
 /**
- * Free previosuly allocated memory
+ * Free previously allocated memory
  *
  * \param   dev	       - \c [in] Device handle. See #amdgpu_device_initialize()
  * \param   buf_handle - \c [in]  Buffer handle to free
@@ -731,7 +731,7 @@ int amdgpu_bo_free(amdgpu_bo_handle buf_handle);
 void amdgpu_bo_inc_ref(amdgpu_bo_handle bo);
 
 /**
- * Request CPU access to GPU accessable memory
+ * Request CPU access to GPU accessible memory
  *
  * \param   buf_handle - \c [in] Buffer handle
  * \param   cpu        - \c [out] CPU address to be used for access
@@ -1231,7 +1231,7 @@ int amdgpu_read_mm_registers(amdgpu_device_handle dev, unsigned dword_offset,
  * \notes \n
  * It is client responsibility to correctly handle VA assignments and usage.
  * Neither kernel driver nor libdrm_amdpgu are able to prevent and
- * detect wrong va assignemnt.
+ * detect wrong va assignment.
  *
  * It is client responsibility to correctly handle multi-GPU cases and to pass
  * the corresponding arrays of all devices handles where corresponding VA will
diff --git a/etnaviv/etnaviv_priv.h b/etnaviv/etnaviv_priv.h
index e45d364cc74126073ea6..eef7f49c09d7bf14e1c9 100644
--- a/etnaviv/etnaviv_priv.h
+++ b/etnaviv/etnaviv_priv.h
@@ -150,7 +150,7 @@ struct etna_cmd_stream_priv {
 	struct etna_bo **bos;
 	uint32_t nr_bos, max_bos;
 
-	/* notify callback if buffer reset happend */
+	/* notify callback if buffer reset happened */
 	void (*reset_notify)(struct etna_cmd_stream *stream, void *priv);
 	void *reset_notify_priv;
 };
diff --git a/exynos/exynos_drm.c b/exynos/exynos_drm.c
index 078bf2c59caf84e2fb80..b008ad733e708de9fb84 100644
--- a/exynos/exynos_drm.c
+++ b/exynos/exynos_drm.c
@@ -276,7 +276,7 @@ drm_public uint32_t exynos_bo_handle(struct exynos_bo *bo)
  * @bo: a exynos buffer object including a gem object handle to be mmapped
  *	to user space.
  *
- * if true, user pointer mmaped else NULL.
+ * if true, user pointer mmapped else NULL.
  */
 drm_public void *exynos_bo_map(struct exynos_bo *bo)
 {
diff --git a/exynos/exynos_drm.h b/exynos/exynos_drm.h
index c3af0ac5f6d9ae95f911..50181c40f21370ffa05a 100644
--- a/exynos/exynos_drm.h
+++ b/exynos/exynos_drm.h
@@ -64,7 +64,7 @@ struct drm_exynos_gem_info {
 /**
  * A structure for user connection request of virtual display.
  *
- * @connection: indicate whether doing connetion or not by user.
+ * @connection: indicate whether doing connection or not by user.
  * @extensions: if this value is 1 then the vidi driver would need additional
  *	128bytes edid data.
  * @edid: the edid data pointer from user side.
diff --git a/exynos/exynos_drmif.h b/exynos/exynos_drmif.h
index 154439bb8dae3e1e2f15..bcf85951765b4a2bb19a 100644
--- a/exynos/exynos_drmif.h
+++ b/exynos/exynos_drmif.h
@@ -46,7 +46,7 @@ struct exynos_device {
  * @handle: a gem handle to gem object created.
  * @flags: indicate memory allocation and cache attribute types.
  * @size: size to the buffer created.
- * @vaddr: user space address to a gem buffer mmaped.
+ * @vaddr: user space address to a gem buffer mmapped.
  * @name: a gem global handle from flink request.
  */
 struct exynos_bo {
diff --git a/freedreno/kgsl/README b/freedreno/kgsl/README
index 56874b42ff24ac2abe10..c46ba08b9d8d6faa3ed8 100644
--- a/freedreno/kgsl/README
+++ b/freedreno/kgsl/README
@@ -1,4 +1,4 @@
-This is a historical discription of what is now the kgsl backend
+This is a historical description of what is now the kgsl backend
 in libdrm freedreno (before the upstream drm/msm driver).  Note
 that the kgsl backend requires the "kgsl-drm" shim driver, which
 usually is in disrepair (QCOM does not build it for android), and
diff --git a/freedreno/msm/msm_ringbuffer.c b/freedreno/msm/msm_ringbuffer.c
index 475c65d78358c2701c60..7b9df4a041afa68fedac 100644
--- a/freedreno/msm/msm_ringbuffer.c
+++ b/freedreno/msm/msm_ringbuffer.c
@@ -74,7 +74,7 @@ struct msm_ringbuffer {
 	/* should have matching entries in submit.cmds: */
 	DECLARE_ARRAY(struct msm_cmd *, cmds);
 
-	/* List of physical cmdstream buffers (msm_cmd) assocated with this
+	/* List of physical cmdstream buffers (msm_cmd) associated with this
 	 * logical fd_ringbuffer.
 	 *
 	 * Note that this is different from msm_ringbuffer::cmds (which
diff --git a/intel/intel_bufmgr_priv.h b/intel/intel_bufmgr_priv.h
index 7e360a0b23d4a59b457c..baaf4bb644af529ec813 100644
--- a/intel/intel_bufmgr_priv.h
+++ b/intel/intel_bufmgr_priv.h
@@ -156,7 +156,7 @@ struct _drm_intel_bufmgr {
 	 * address range (2^48).
 	 *
 	 * Any resource used with flat/heapless (0x00000000-0xfffff000)
-	 * General State Heap (GSH) or Intructions State Heap (ISH) must
+	 * General State Heap (GSH) or Instructions State Heap (ISH) must
 	 * be in a 32-bit range. 48-bit range will only be used when explicitly
 	 * requested.
 	 *
diff --git a/intel/mm.h b/intel/mm.h
index 1b0f84fcc4bd6011db2c..be3d90d4beb6370e8851 100644
--- a/intel/mm.h
+++ b/intel/mm.h
@@ -73,7 +73,7 @@ drm_private extern int mmFreeMem(struct mem_block *b);
 drm_private extern void mmDestroy(struct mem_block *mmInit);
 
 /**
- * For debuging purpose.
+ * For debugging purpose.
  */
 drm_private extern void mmDumpMemInfo(const struct mem_block *mmInit);
 
diff --git a/libkms/libkms.pc.in b/libkms/libkms.pc.in
index 1421b3eaae5919bbf69e..7c6042946f3271372d7c 100644
--- a/libkms/libkms.pc.in
+++ b/libkms/libkms.pc.in
@@ -4,7 +4,7 @@ libdir=@libdir@
 includedir=@includedir@
 
 Name: libkms
-Description: Library that abstract aways the different mm interface for kernel drivers
+Description: Library that abstracts away the different mm interface for kernel drivers
 Version: 1.0.0
 Libs: -L${libdir} -lkms
 Cflags: -I${includedir}/libkms
diff --git a/man/drm.xml b/man/drm.xml
index 1f559669427e97bc090f..dbb67adc8f5b8fc7608d 100644
--- a/man/drm.xml
+++ b/man/drm.xml
@@ -49,7 +49,7 @@
           applications.</para>
 
     <para>In earlier days, the kernel framework was solely used to provide raw
-          hardware access to priviledged user-space processes which implement
+          hardware access to privileged user-space processes which implement
           all the hardware abstraction layers. But more and more tasks were
           moved into the kernel. All these interfaces are based on
           <citerefentry><refentrytitle>ioctl</refentrytitle><manvolnum>2</manvolnum></citerefentry>
@@ -64,7 +64,7 @@
           <citerefentry><refentrytitle>open</refentrytitle><manvolnum>2</manvolnum></citerefentry>
           and
           <citerefentry><refentrytitle>close</refentrytitle><manvolnum>2</manvolnum></citerefentry>.
-          However, it still depends on the grapics driver which interfaces are
+          However, it still depends on the graphics driver which interfaces are
           available on these devices. If an interface is not available, the
           syscalls will fail with <literal>EINVAL</literal>.</para>
 
diff --git a/meson.build b/meson.build
index b748fb2f599e41ddc885..ba88063279939c3561b4 100644
--- a/meson.build
+++ b/meson.build
@@ -157,7 +157,7 @@ if _vc4 != 'false'
   with_vc4 = _vc4 == 'true' or ['arm', 'aarch64'].contains(host_machine.cpu_family())
 endif
 
-# XXX: Aparently only freebsd and dragonfly bsd actually need this (and
+# XXX: Apparently only freebsd and dragonfly bsd actually need this (and
 # gnu/kfreebsd), not openbsd and netbsd
 with_libkms = false
 _libkms = get_option('libkms')
diff --git a/tests/amdgpu/amdgpu_test.c b/tests/amdgpu/amdgpu_test.c
index ebf4409868081e8b00f4..f0b2ccb4400308df46eb 100644
--- a/tests/amdgpu/amdgpu_test.c
+++ b/tests/amdgpu/amdgpu_test.c
@@ -234,7 +234,7 @@ static const char usage[] =
 static const char options[]   = "hlrps:t:b:d:f";
 
 /* Open AMD devices.
- * Return the number of AMD device openned.
+ * Return the number of AMD device opened.
  */
 static int amdgpu_open_devices(int open_render_node)
 {
@@ -322,7 +322,7 @@ static void amdgpu_print_devices()
 	int i;
 	drmDevicePtr device;
 
-	/* Open the first AMD devcie to print driver information. */
+	/* Open the first AMD device to print driver information. */
 	if (drm_amdgpu[0] >=0) {
 		/* Display AMD driver version information.*/
 		drmVersionPtr retval = drmGetVersion(drm_amdgpu[0]);
diff --git a/tests/ttmtest/src/xf86dristr.h b/tests/ttmtest/src/xf86dristr.h
index 3b43438e7f70dc15a499..2730d1a7e975c6b5de1d 100644
--- a/tests/ttmtest/src/xf86dristr.h
+++ b/tests/ttmtest/src/xf86dristr.h
@@ -42,8 +42,8 @@ SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 
 #define XF86DRINAME "XFree86-DRI"
 
-/* The DRI version number.  This was originally set to be the same of the
- * XFree86 version number.  However, this version is really indepedent of
+/* The DRI version number.  This was originally set to be the same as the
+ * XFree86 version number.  However, this version is really independent of
  * the XFree86 version.
  *
  * Version History:
diff --git a/xf86drm.c b/xf86drm.c
index c4a2b424599da85278d2..377ddf917d2cb902899a 100644
--- a/xf86drm.c
+++ b/xf86drm.c
@@ -179,7 +179,7 @@ drm_public void drmFree(void *pt)
 }
 
 /**
- * Call ioctl, restarting if it is interupted
+ * Call ioctl, restarting if it is interrupted
  */
 drm_public int
 drmIoctl(int fd, unsigned long request, void *arg)
@@ -289,7 +289,7 @@ static int drmMatchBusID(const char *id1, const char *id2, int pci_domain_ok)
  *
  * \internal
  * Checks for failure. If failure was caused by signal call chown again.
- * If any other failure happened then it will output error mesage using
+ * If any other failure happened then it will output error message using
  * drmMsg() call.
  */
 #if !UDEV
@@ -1458,7 +1458,7 @@ drm_public int drmDMA(int fd, drmDMAReqPtr request)
  *
  * \param fd file descriptor.
  * \param context context.
- * \param flags flags that determine the sate of the hardware when the function
+ * \param flags flags that determine the state of the hardware when the function
  * returns.
  *
  * \return always zero.
diff --git a/xf86drmMode.h b/xf86drmMode.h
index 3cd27aee9ab7bc67d2c8..a32902f73289368b9e22 100644
--- a/xf86drmMode.h
+++ b/xf86drmMode.h
@@ -49,12 +49,12 @@ extern "C" {
  * header defining uint32_t, int32_t and uint16_t.
  *
  * It aims to provide a randr1.2 compatible interface for modesettings in the
- * kernel, the interface is also ment to be used by libraries like EGL.
+ * kernel, the interface is also meant to be used by libraries like EGL.
  *
  * More information can be found in randrproto.txt which can be found here:
  * http://gitweb.freedesktop.org/?p=xorg/proto/randrproto.git
  *
- * There are some major diffrences to be noted. Unlike the randr1.2 proto you
+ * There are some major differences to be noted. Unlike the randr1.2 proto you
  * need to create the memory object of the framebuffer yourself with the ttm
  * buffer object interface. This object needs to be pinned.
  */
@@ -348,7 +348,7 @@ extern void drmModeFreePlane( drmModePlanePtr ptr );
 extern void drmModeFreePlaneResources(drmModePlaneResPtr ptr);
 
 /**
- * Retrives all of the resources associated with a card.
+ * Retrieves all of the resources associated with a card.
  */
 extern drmModeResPtr drmModeGetResources(int fd);
 
@@ -357,7 +357,7 @@ extern drmModeResPtr drmModeGetResources(int fd);
  */
 
 /**
- * Retrive information about framebuffer bufferId
+ * Retrieve information about framebuffer bufferId
  */
 extern drmModeFBPtr drmModeGetFB(int fd, uint32_t bufferId);
 
@@ -397,7 +397,7 @@ extern int drmModeDirtyFB(int fd, uint32_t bufferId,
  */
 
 /**
- * Retrive information about the ctrt crtcId
+ * Retrieve information about the ctrt crtcId
  */
 extern drmModeCrtcPtr drmModeGetCrtc(int fd, uint32_t crtcId);
 